#ifndef EFL_ANIMATOR_EO_HH
#define EFL_ANIMATOR_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { 
struct Animator;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Animator> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct Animator {
   static Eo_Class const* _eo_class()
   {
      return EFL_ANIMATOR_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Animator() const;
   operator ::efl::Animator&();
   operator ::efl::Animator const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Animator> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Animator const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Animator : ::efl::eo::concrete
{
   explicit Animator( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Animator(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Animator(Animator const& other) = default;
   Animator(Animator&& other) = default;
   Animator& operator=(Animator const& other) = default;
   Animator& operator=(Animator&& other) = default;
   Animator()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Animator( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Animator(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EFL_ANIMATOR_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct animator_tick_event
   {
      static Eo_Event_Description const* description()
      { return EFL_EVENT_ANIMATOR_TICK; }
      typedef Efl_Event_Animator_Tick parameter_type;
   } const animator_tick_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Animator> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Animator const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Animator) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Animator>::value, "");
} 
#include "efl_animator.eo.impl.hh"
#endif
